define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var biz = require("$UI/system/lib/biz");
	require("$UI/BJBusWYST/commonjs/common");

	var Model = function() {
		this.callParent();
	};

	var stbh = '';
	var mealTime = '';
	var xph = 'DAB490A5';
	
	//从主页面迁移到该页面
	Model.prototype.indexReceiverReceive = function(event) {
		stbh = event.data;
		this.initFood();
		this.comp('contents2').to('foodContent');
	};
	
	//初始化紧急售餐页面
	Model.prototype.initFood = function(event) {
		//取得餐次
		var params = new biz.Request.ActionParam();
		params.setString("stbh", stbh);
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "getMealTime",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					mealTime = resultData.response;
				} else {
					throw new Error("取得餐次失败！");
				}
			}
		});
		
		if(mealTime === null || mealTime ===''){
			alert('现在不是用餐时段！');
			return;
		}

		//刷新紧急售餐一览
		this.comp("foodData").confirmRefresh = false;
		this.comp("list3").refresh(true);
	};

	// 接管foodData的刷新
	Model.prototype.foodDataCustomRefresh = function(event) {	
		var foodData = this.comp('foodData');
		var params = new biz.Request.ActionParam();
		params.setString("STBH", stbh);
		params.setString("CC", mealTime);

		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "queryMenuList",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					foodData.loadData(resultData.response);
				} else {
					throw new Error("取得菜单一览数据失败！");
				}
			}
		});
	};

	// [返回]
	Model.prototype.indexBtnClick = function(event) {
		this.comp('indexReceiver').windowEnsure();
	};
	// ======================紧急售餐======================//
	// [+]
	Model.prototype.addCountBtnClick = function(event) {
		var row = event.bindingContext.$object;
		if(row.val("XZFS") - row.val('FS') - row.val('DDFS') <= 0)
		{
			this.comp('messageDialog1').show();
			return;
		}
		row.val("FS", row.val("FS") + 1);
		var cartData = this.comp('cartData');
		if (cartData.find([ 'fFoodID' ], [ row.val('b') ]).length === 0) {
			cartData.newData({
				index : 0,
				defaultValues : [ {
					"fFoodID" : row.val("b"),
					"STBH" : row.val("STBH"),
					"CPBH" : row.val("CPBH"),
					"CPMC" : row.val("CPMC"),
					"TP" : row.val("TP"),
					"JG" : row.val("JG"),
					"FS" : row.val("FS")
				} ]
			});
		} else {
			cartData.to(row.val('b'));
			cartData.setValue('FS', row.val('FS'));
		}
	};

	// [-]
	Model.prototype.reduceCountBtnClick = function(event) {
		var row = event.bindingContext.$object;
		row.val("FS", (row.val("FS") > 0) ? row.val("FS") - 1 : 0);

		var cartData = this.comp('cartData');
		if (row.val('FS') > 0) {
			cartData.to(row.val('b'));
			cartData.setValue('FS', row.val('FS'));
		} else {
			cartData.confirmDelete = false;
			cartData.directDeleteMode = true;
			cartData.to(row.val('b'));
			cartData.deleteData(cartData.getCurrentRow());
		}
	};

	// ======================我的菜单======================//	
	// [扣款]
	Model.prototype.deductBtnClick = function(event) {
		this.comp('swipeCardDialog').open({data:{stbh:stbh,contentNm:'foodC'}});
	};
	
	// 实际扣款（订单表、订单详细表、消费流水表、卡片信息表）
	Model.prototype.deductMoney = function(event) {
		this.getPerson1Data();
		var orderMoney = document.getElementById(this.getIDByXID('output20')).innerHTML.replace('￥', '');
		stbh =event.data.stbh;
		xph =event.data.xph;
		
		if(xph !== null && xph !== '')
		{
			var person1Data = this.comp('person1Data');
			var cartData = this.comp('cartData');
			var cpbhAll = '';
			
			//取得将菜品编号合并成一个字符串
			cartData.each(function(options) {
				cpbhAll += options.row.val('CPBH')+",";
			});
			cpbhAll = cpbhAll.substring(0,cpbhAll.length - 1);
	
			// 更新卡片表的余额
			var kpxxData = this.comp('kpxxData');
			kpxxData.filters.clear();
			kpxxData.setFilter('xphFilter', "YGKXPXLH = '" + xph + "'");
			kpxxData.refreshData();
			if(kpxxData.getCount()>0){
				person1Data.setValue('KPYE', kpxxData.val('KPYE'));
				person1Data.setValue('CZJE', orderMoney);
				kpxxData.setValue('KPYE',kpxxData.val('KPYE') - orderMoney);
			}
	
			// 给消费流水表赋值
			var xflsData = this.comp('xflsData');
			xflsData.newData({
				defaultValues : [ {
					"YGKXPXLH":(Math.random()*10).toString().replace('.',''),
					"XFLX":'2',
					"SBZCH":'1',
					"ZDJYLSH":'1',
					"XFJE":orderMoney,
					"STBH":stbh,
					"CPBH":cpbhAll,
					"CC":mealTime,
					"GMSFHM":person1Data.val('GMSFHM'),
					"XM":person1Data.val('XM')
				} ]
			});	
		
			// 保存消费流水表
			xflsData.saveData();
		}
	};

	// 保存消费流水表之前，保存订单表、订单详细、卡片信息表
	Model.prototype.xflsDataBeforeSave = function(event) {
		this.comp('kpxxData').saveData();
	};

	// 扣款成功
	Model.prototype.xflsDataSaveCommit = function(event){
		var person1Data = this.comp('person1Data');	
		this.comp('okMsg').show({message:'扣款前余额：￥' + person1Data.val('KPYE') + '\r\n' + '&nbsp;&nbsp;&nbsp;消费合计：<font style="font-weight:bold;" color = red>￥' + person1Data.val('CZJE')+'</font>' + '\r\n' + '扣款后余额：￥' + person1Data.val('CHYE')});
		this.comp('contents2').to('cartContent');
	};
	Model.prototype.okMsgClose = function(event){
		this.comp('cartData').clear();
		this.comp('contents2').to('foodContent');
	};

	// 扣款失败
	Model.prototype.xflsDataSaveError = function(event) {
		this.comp('okErrorMsg').show();	
		this.comp('contents2').to('foodContent');
	};

	// [取消]
	Model.prototype.cancelOrderBtnClick = function(event) {
		var cartData = this.comp('cartData');
		var foodData = this.comp('foodData');
		cartData.confirmDelete = false;
		cartData.directDeleteMode = true;
		cartData.deleteAllData();
		
		foodData.each(function(options) {
			options.row.val('FS', 0);
		});
	};

	// ======================我的订单======================//
	Model.prototype.orderContentBtnClick = function(event){
		this.comp('swipeCardDialog').open({data:{stbh:stbh,contentNm:'orderC'}});
	};
	
	//初始化订单页面
	Model.prototype.initOrder = function(event) {
		var orderData = this.comp('orderData');
		orderData.filters.clear();
		orderData.setFilter('stbhFilter', "STBH='" + stbh + "'");
		orderData.setFilter('ddzt', "DDZT='1'");
		orderData.confirmRefresh =false;
		this.comp("list5").refresh(true);
	};
	
	//[取餐]
	Model.prototype.orderliClick = function(event) {
		var orderData = this.comp("orderData");
		var id = orderData.getRowID(event.bindingContext.$object);
		orderData.to(id);
		this.comp("takeMealDialog").open({
			data : orderData.val('DDBH')
		});		
	};

	Model.prototype.takeMealDialogReceive = function(event) {
		this.comp('contents2').to('foodContent');
	};

	// ======================充值======================//
	Model.prototype.rechargeContentBtnClick = function(event){
		this.comp('swipeCardDialog').open({data:{stbh:stbh,contentNm:'rechargeC'}});
	};

	// 初始化充值页面
	Model.prototype.initRecharge = function(event) {	
		var personData = this.comp('personData');
		var params = new biz.Request.ActionParam();
		params.setString("YGKXPXLH", xph);// 5DB7FF31/DAB490A5

		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "queryPersonInfo",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					personData.loadData(resultData.response);
					personData.refreshData();
				} else {
					this.comp('getPersonInfoMsg').show;
				}
			}
		});
	};
	
	//[充值]
	Model.prototype.rechargeBtnClick = function(event) {
	debugger;
		var personData = this.comp('personData');
		var rechangeMoney = document.getElementById(this.getIDByXID('input1')).value;
		var remainMoney = document.getElementById(this.getIDByXID('output11')).innerHTML.replace('￥', '');
		//var reg1 =  /^\d+$/;
		var type="^[0-9]*[1-9][0-9]*$"; 
        var re = new RegExp(type); 
		
		if (!IsNum(rechangeMoney)) {
			alert("请输入数字！");
		} else if(rechangeMoney.trim().match(re) === null){
			this.comp('okMsg').show({message:'请输入大于0的正整数！'});
			this.comp('contents2').to('rechargeContent');
		}else {	
			// 更新卡片表的余额
			var kpxxData = this.comp('kpxxData');
			kpxxData.filters.clear();
			kpxxData.setFilter('xphFilter', "YGKXPXLH = '"+ xph +"'");
			kpxxData.refreshData();
			if(kpxxData.getCount()>0){
				kpxxData.setValue('KPYE',remainMoney);
			}

			// 给充值流水表赋值
			var czlsData = this.comp('czlsData');
			czlsData.newData({
				defaultValues : [ {
					"YGKXPXLH":(Math.random()*10).toString().replace('.',''),
					"SBZCH":'1',
					"CZJE":rechangeMoney,
					"STBH":stbh,
					"GMSFHM":personData.val('GMSFHM'),
					"XM":personData.val('XM')
				} ]
			});
			czlsData.saveData();
		}
	};

	// 保存充值流水表之前，保存卡片信息表
	Model.prototype.czlsDataBeforeSave = function(event){
		this.comp('kpxxData').saveData();
	};

	//充值成功
	Model.prototype.czlsDataSaveCommit = function(event){	
		var personData = this.comp('personData');
		this.comp('okMsg').show({title:'充值成功！',
								message:'充值前金额：￥' + personData.val('KPYE') + '\r\n' + '&nbsp;&nbsp;&nbsp;充值金额：<font style="font-weight:bold;" color = red>￥' + personData.val('CZJE')+'</font>' + '\r\n' + '充值后金额：￥' + personData.val('CHYE')});
	};
	Model.prototype.okMsgOK = function(event){
		this.comp('contents2').to('foodContent');
	};
	
	//充值失败
	Model.prototype.czlsDataSaveError = function(event){
		this.comp('okErrorMsg').show({message:'充值失败！'});	
	};
	
	// 扣款、充值时，取得人员信息
	Model.prototype.getPerson1Data = function(event) {	
		var person1Data = this.comp('person1Data');
		var params = new biz.Request.ActionParam();
		params.setString("YGKXPXLH", xph);// 5DB7FF31/DAB490A5

		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "queryPersonInfo",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					person1Data.loadData(resultData.response);
					person1Data.confirmRefresh = false;
					person1Data.refreshData();
				} else {
					this.comp('getPersonInfoMsg').show;
				}
			}
		});
	};
	
	// 刷卡后，实际扣款||显示我的订单||充值
	Model.prototype.swipeCardDialogReceive = function(event){
		stbh = event.data.stbh;
		this.initFood();
		xph = event.data.chipNum;
		if(event.data.contentNm === 'foodC'){		
			this.deductMoney({data:{stbh:stbh,xph:xph}});
		}else if(event.data.contentNm === 'orderC'){			
			this.initOrder();
			this.comp('contents2').to('orderContent');
		}else if(event.data.contentNm === 'rechargeC'){	
			this.initRecharge();
			this.comp('contents2').to('rechargeContent');
		}
	};		

	return Model;
});